// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from smacc2_msgs:msg/SmaccEventGenerator.idl
// generated code does not contain a copyright notice

#ifndef SMACC2_MSGS__MSG__DETAIL__SMACC_EVENT_GENERATOR__FUNCTIONS_H_
#define SMACC2_MSGS__MSG__DETAIL__SMACC_EVENT_GENERATOR__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "smacc2_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "smacc2_msgs/msg/detail/smacc_event_generator__struct.h"

/// Initialize msg/SmaccEventGenerator message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * smacc2_msgs__msg__SmaccEventGenerator
 * )) before or use
 * smacc2_msgs__msg__SmaccEventGenerator__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
bool
smacc2_msgs__msg__SmaccEventGenerator__init(smacc2_msgs__msg__SmaccEventGenerator * msg);

/// Finalize msg/SmaccEventGenerator message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
void
smacc2_msgs__msg__SmaccEventGenerator__fini(smacc2_msgs__msg__SmaccEventGenerator * msg);

/// Create msg/SmaccEventGenerator message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * smacc2_msgs__msg__SmaccEventGenerator__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
smacc2_msgs__msg__SmaccEventGenerator *
smacc2_msgs__msg__SmaccEventGenerator__create();

/// Destroy msg/SmaccEventGenerator message.
/**
 * It calls
 * smacc2_msgs__msg__SmaccEventGenerator__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
void
smacc2_msgs__msg__SmaccEventGenerator__destroy(smacc2_msgs__msg__SmaccEventGenerator * msg);


/// Initialize array of msg/SmaccEventGenerator messages.
/**
 * It allocates the memory for the number of elements and calls
 * smacc2_msgs__msg__SmaccEventGenerator__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
bool
smacc2_msgs__msg__SmaccEventGenerator__Sequence__init(smacc2_msgs__msg__SmaccEventGenerator__Sequence * array, size_t size);

/// Finalize array of msg/SmaccEventGenerator messages.
/**
 * It calls
 * smacc2_msgs__msg__SmaccEventGenerator__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
void
smacc2_msgs__msg__SmaccEventGenerator__Sequence__fini(smacc2_msgs__msg__SmaccEventGenerator__Sequence * array);

/// Create array of msg/SmaccEventGenerator messages.
/**
 * It allocates the memory for the array and calls
 * smacc2_msgs__msg__SmaccEventGenerator__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
smacc2_msgs__msg__SmaccEventGenerator__Sequence *
smacc2_msgs__msg__SmaccEventGenerator__Sequence__create(size_t size);

/// Destroy array of msg/SmaccEventGenerator messages.
/**
 * It calls
 * smacc2_msgs__msg__SmaccEventGenerator__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
void
smacc2_msgs__msg__SmaccEventGenerator__Sequence__destroy(smacc2_msgs__msg__SmaccEventGenerator__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // SMACC2_MSGS__MSG__DETAIL__SMACC_EVENT_GENERATOR__FUNCTIONS_H_
